package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.UserCouponService;
import com.gxwebsoft.shop.entity.UserCoupon;
import com.gxwebsoft.shop.param.UserCouponParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户优惠券记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-25 19:04:43
 */
@Api(tags = "用户优惠券记录表管理")
@RestController
@RequestMapping("/api/shop/user-coupon")
public class UserCouponController extends BaseController {
    @Resource
    private UserCouponService userCouponService;

    @PreAuthorize("hasAuthority('shop:userCoupon:list')")
    @OperationLog
    @ApiOperation("分页查询用户优惠券记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserCoupon>> page(UserCouponParam param) {
        PageParam<UserCoupon, UserCouponParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userCouponService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(userCouponService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:list')")
    @OperationLog
    @ApiOperation("查询全部用户优惠券记录表")
    @GetMapping()
    public ApiResult<List<UserCoupon>> list(UserCouponParam param) {
        PageParam<UserCoupon, UserCouponParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userCouponService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(userCouponService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:list')")
    @OperationLog
    @ApiOperation("根据id查询用户优惠券记录表")
    @GetMapping("/{id}")
    public ApiResult<UserCoupon> get(@PathVariable("id") Integer id) {
        return success(userCouponService.getById(id));
        // 使用关联查询
        //return success(userCouponService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:save')")
    @OperationLog
    @ApiOperation("添加用户优惠券记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserCoupon userCoupon) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          userCoupon.setUserId(loginUser.getUserId());
        }
        if (userCouponService.save(userCoupon)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:update')")
    @OperationLog
    @ApiOperation("修改用户优惠券记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserCoupon userCoupon) {
        if (userCouponService.updateById(userCoupon)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:remove')")
    @OperationLog
    @ApiOperation("删除用户优惠券记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userCouponService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:save')")
    @OperationLog
    @ApiOperation("批量添加用户优惠券记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserCoupon> list) {
        if (userCouponService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:update')")
    @OperationLog
    @ApiOperation("批量修改用户优惠券记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserCoupon> batchParam) {
        if (batchParam.update(userCouponService, "user_coupon_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:remove')")
    @OperationLog
    @ApiOperation("批量删除用户优惠券记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userCouponService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
